Summary
PivotTables can be sorted in the following ways:
Sort By Field Item Name
Sort By Value
Sort By Custom Field Item Value
Sort By Custom Callback
Sort By Custom Sort List
The sortType can be set in any way.
API
Interface
PivotTable APIs
PivotTableManager APIs
Sample Code
window.onload = function () {
let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 });
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getSource(sheet2, pivotSales);
window.pivotTable = addPivotTable(sheet1, tableName);
window.spread = spread;
bindEvent(spread);
initFormulaTextBox(spread);
syncSortInfoToDOM();
spread.resumePaint();
spread.focus();
}
function getSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function addPivotTable(sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
function _isNullOrUndefined(obj) {
return obj === null || obj === undefined;
}
function bindEvent(spread) {
_getElementById("setSortInfo").addEventListener("click", function (e) {
let sortInfo = generateSortInfo();
if (sortInfo) {
const autoSortState = getAutoSort();
const firstKeyList = getFirstKeyList();
const fieldName= getSortFieldName();
pivotTable.autoSortState(fieldName, autoSortState);
spread.getActiveSheet().pivotTables.customList(firstKeyList);
pivotTable.sort(fieldName, sortInfo);
_rangeSelector.endSelectMode();
spread.focus();
}
});
_getElementById("clearSortInfo").addEventListener("click", function (e) {
pivotTable.sort(getSortFieldName(), null);
//syncSortInfoToDOM();
_rangeSelector.endSelectMode();
spread.focus();
});
_getElementById("sort-field").addEventListener("change", function (e) {
syncSortInfoToDOM();
});
const sortByContainer = document.getElementById('sortTypeContainer');
sortByContainer.addEventListener('change', (e) => {
const t = e.target;
if (t.matches('input[type="radio"]')) {
displayCustomListOrSortByValue();
syncFirstKeyListDisabledState();
}
});
_getElementById('autoSort').addEventListener('change', (e)=>{
syncFirstKeyListDisabledState();
});
_getElementById("value-field-name").addEventListener('change', (e)=>{
syncFirstKeyListDisabledState();
});
}
function syncFirstKeyListDisabledState () {
const disabled = getAutoSort() || getSortType() === 2 || !!getValueFieldName();
const firstKeyList = _getElementById('firstKeyList');
firstKeyList.disabled = disabled;
if (disabled) {
firstKeyList.classList.add('disabled-style');
} else {
firstKeyList.classList.remove('disabled-style');
}
}
function displayCustomListOrSortByValue() {
if (getSortType() === 2) {
getCustomSortListContainer().style.display='block';
getSortByValueContainer().style.display='none';
} else {
getCustomSortListContainer().style.display='none';
getSortByValueContainer().style.display='block';
}
}
function initFormulaTextBox(spread) {
let host = _getElementById("formulaTextBox");
window._rangeSelector = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(host, {
rangeSelectMode: true,
absoluteReference: true,
needSheetName: false
}, spread);
_rangeSelector.workbook(spread);
}
function getSortFieldName() {
return _getElementById("sort-field").value;
}
function getSortType() {
var obj = document.getElementsByName("sort-type");
for (var i in obj) {
if (obj[i].checked == true) {
return +obj[i].value;
}
}
}
function setSortType(type) {
var obj = document.getElementsByName("sort-type");
for (var i in obj) {
if (obj[i].value === type + '') {
obj[i].checked = "checked";
break;
}
}
}
function getAutoSort() {
return _getElementById('autoSort').checked;
}
function setAutoSort(isAutoSort) {
_getElementById('autoSort').checked = isAutoSort;
}
function getSortByValueContainer () {
return _getElementById('sortByValueContainer');
}
function getCustomSortListContainer () {
return _getElementById('customSortListContainer');
}
function getFirstKeyList () {
const value = _getElementById('firstKeyList').value;
if (!value) {
return value;
}
return value.split(',');
}
function setCustomList (list) {
let value = '';
if (Array.isArray(list)) {
value = list.join(',');
}
_getElementById('customSortList').value = value;
}
function getCustomList () {
const value = _getElementById('customSortList').value;
if (!value) {
return value;
}
return value.split(',');
}
function getValueFieldName() {
return _getElementById("value-field-name").value;
}
function setValueFieldName(name) {
_getElementById("value-field-name").value = name;
}
function initPivotReferences() {
var cellRef = _rangeSelector.text();
if (!cellRef || !getValueFieldName()) {
return;
}
var spread = _rangeSelector.workbook();
var sheet = spread.getActiveSheet();
var range = GC.Spread.Sheets.CalcEngine.formulaToRange(sheet, _rangeSelector.text());
if (range) {
var row = range.row, col = range.col;
if (sheet.pivotTables.findPivotTable(row, col)) {
var pivotInfo = pivotTable.getPivotInfo(row, col);
var fieldArea = pivotTable.getField(getSortFieldName()).pivotArea;
var infos;
if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.rowField) {
infos = pivotInfo.colInfos;
}
if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.columnField) {
infos = pivotInfo.rowInfos;
}
if (infos && infos.length > 0) {
var isGrandTotal = infos.length === 1 && infos[0].isGrandTotal;
if (!isGrandTotal) { // if is grand total, nothing to do.
return infos.map((info) => {
return {
fieldName: info.fieldName,
items: [info.itemName]
};
});
}
}
}
}
}
function setPivotReferences(pivotReferences) {
var rangeStr = '', resultRow, resultCol;
if (pivotReferences) {
var refSourceNames = pivotReferences.map(ref => ref.fieldName);
var allFields = pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.rowField).concat(pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.columnField));
var pivotArea = {
references: allFields.map(function (field) {
var index = refSourceNames.indexOf(field.sourceName);
if (index !== -1) {
return {
fieldName: field.fieldName,
items: pivotReferences[index].items
}
} else {
return {
fieldName: field.fieldName
}
}
})
}
var range = pivotTable.getPivotAreaRanges(pivotArea)[0];
resultRow = range.row;
resultCol = range.col;
rangeStr = GC.Spread.Sheets.CalcEngine.rangeToFormula(new GC.Spread.Sheets.Range(resultRow, resultCol, 1, 1));
}
_rangeSelector.text(rangeStr);
}
function generateSortInfo() {
var sortFieldName = getSortFieldName();
var sortType = getSortType();
var sortValueFieldName = getValueFieldName();
var pivotReferences = initPivotReferences();
if (_isNullOrUndefined(sortFieldName) || _isNullOrUndefined(sortType)) {
return;
}
var sortInfo = {
sortType: sortType
};
if (sortType === 2) {
sortInfo.customSortList = getCustomList();
} else {
if (!_isNullOrUndefined(sortValueFieldName) && sortValueFieldName !== '') {
sortInfo.sortValueFieldName = sortValueFieldName;
}
if (!_isNullOrUndefined(pivotReferences)) {
sortInfo.sortByPivotReferences = pivotReferences;
}
}
return sortInfo;
}
function syncSortInfoToDOM() {
const fieldName = getSortFieldName();
const autoSortState = pivotTable.autoSortState(fieldName)
setAutoSort(autoSortState);
var sortInfo = pivotTable.sort(fieldName);
var sortType = sortInfo && sortInfo.sortType;
if (_isNullOrUndefined(sortType)) {
sortType = GC.Spread.Pivot.SortType.asc;
}
setSortType(sortType);
displayCustomListOrSortByValue();
if (sortType === 2) {
setCustomList(sortInfo?.customSortList);
} else {
var sortValueFieldName = sortInfo && sortInfo.sortValueFieldName;
if (_isNullOrUndefined(sortValueFieldName)) {
sortValueFieldName = '';
}
setValueFieldName(sortValueFieldName);
var pivotReferences = sortInfo && sortInfo.sortByPivotReferences;
setPivotReferences(pivotReferences);
}
syncFirstKeyListDisabledState();
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js"
type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js"
type="text/javascript"></script>
<script
src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js"
type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="options-row">
<span>First key sort order:</span>
</div>
<div class="options-row">
<input type="text" id="firstKeyList" class="text-input" placeholder="Separate different items with commas"/>
</div>
<hr>
<div class="options-row">
<span>Sort Field:</span>
<select id="sort-field">
<option value="Salesperson" checked>Salesperson</option>
<option value="Cars">Cars</option>
<option value="Quarters (Date)">Quarters (Date)</option>
</select>
</div>
<div class="options-row" id="autoSortContainer">
<label><input type="checkbox" id="autoSort" value="0" checked>Auto sort</label>
</div>
<div class="options-row">
<span>Sort Type:</span>
</div>
<div class="options-row" id="sortTypeContainer" >
<label><input type="radio" name="sort-type" value="0" checked>Ascending</label>
<label><input type="radio" name="sort-type" value="1">Descending</label>
<label><input type="radio" name="sort-type" value="2">Custom</label>
</div>
<div id="sortByValueContainer">
<div class="options-row">
<span>Value Field Name:</span>
<select id="value-field-name">
<option value="" checked></option>
<option value="Quantity">Quantity</option>
</select>
</div>
<div class="options-row">
<span>Cell Ref:</span>
<div id="formulaTextBox"></div>
</div>
</div>
<div id="customSortListContainer">
<div class="options-row">
<span>Custom sort list:</span>
</div>
<div class="options-row">
<input type="text" id="customSortList" class="text-input" placeholder="Separate different items with commas"/>
</div>
</div>
<hr>
<div class="options-row">
<button id="setSortInfo">Set Sort Info</button>
</div>
<div class="options-row">
<button id="clearSortInfo">Clear Sort Info</button>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 400px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 380px;
padding: 10px;
font-family: Arial, sans-serif;
font-size: 14px;
}
.options-row {
display: flex;
align-items: center;
margin-bottom: 10px;
}
.options-row span {
flex: 1;
margin-right: 10px;
min-width: 100px;
text-align: left;
}
.options-row select,
.options-row input[type="text"] {
flex: 2;
padding: 5px;
border: 1px solid #ccc;
border-radius: 3px;
font-family: inherit;
font-size: inherit;
}
.options-row label {
flex: 2;
}
.options-row button {
flex: 1;
background-color: #007bff;
color: #fff;
padding: 5px 10px;
border: none;
border-radius: 3px;
font-family: inherit;
font-size: inherit;
cursor: pointer;
}
.options-row button:hover {
background-color: #0069d9;
}
input.text-input {
width: 100%;
background-color: white;
padding: 0.625rem 0.75rem;
border: 1px solid #d1d5db;
border-radius: 6px;
font-size: 1rem;
transition: border-color 0.2s, box-shadow 0.2s;
}
input.text-input:focus {
outline: none;
border-color: #3b82f6;
box-shadow: 0 0 0 3px rgba(59, 130, 246, 0.1);
}
.text-input.disabled-style {
background-color: #f3f4f6;
color: #6b7280;
border-color: #d1d5db;
cursor: not-allowed;
}
.text-input.disabled-style::placeholder {
color: #9ca3af;
}
.text-input.disabled-style:focus {
border-color: #d1d5db;
box-shadow: none;
}
#sortTypeContainer, #autoSortContainer {
margin-bottom: 15px;
}
#formulaTextBox {
flex: 2;
padding: 2px 5px;
border: 1px solid #ccc;
border-radius: 3px;
font-family: inherit;
font-size: inherit;
background-color: #fff;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

PivotTable Sort

SpreadJS PivotTables support Sort Data. This function can be used to order and organize data.

Description
app.jsx
app-func.jsx
index.html
styles.css
Copy to CodeMine

Summary

PivotTables can be sorted in the following ways:

  • Sort By Field Item Name
  • Sort By Value
  • Sort By Custom Field Item Value
  • Sort By Custom Callback

The sortType can be set in any way.

enum GC.Pivot.SortType {
    asc,
    desc,
    custom
}

API

Interface

interface GC.Pivot.ICustomSortCallBack
{
    (fieldItemNameArray: any[], sortInfo: GC.Pivot.IPivotCustomSortInfo) : any[];
}
// the usage here is a little different with pivot area, so the interface IPivotReference changes the display way. but actually they are same interface.
interface GC.Spread.Pivot.IPivotReference 
{
   fieldName: string;
   items: string[];
}
interface IPivotViewSortInfo
{
    sortType: GC.Pivot.SortType;
    sortValueFieldName?: string;
    sortByPivotReferences?: GC.Spread.Pivot.IPivotReference[];
    customSortCallback?: GC.Pivot.ICustomSortCallBack;
}

API

/**
 * @description get or set sort for a field of pivot table.
 * @param {string} fieldName Indicates the target field name.
 * @param {GC.Pivot.IPivotViewSortInfo} sortInfo Indicates the sort info.
 * @returns {GC.Pivot.IPivotViewSortInfo | void}
 **/
function sort(fieldName: string, sortInfo: GC.Pivot.IPivotViewSortInfo): GC.Pivot.IPivotViewSortInfo | void

Sample Code

// Get sort info
let sortInfo = pivotTable.sort("Country");

// Clear sort info
pivotTable.sort("Country", null);

// Sort By Field Item Name
var sortInfo = {
    sortType: GC.Pivot.SortType.asc
};
pivotTable.sort("Country", sortInfo);

// Sort By Value
var sortInfo = {
    sortType: GC.Pivot.SortType.asc, sortValueFieldName: 'DAMAGE'
};
pivotTable.sort("Country", sortInfo)

// Sort By Custom Field Item Value
var sortInfo = {
    sortType: GC.Pivot.SortType.desc,
    sortValueFieldName: "DAMAGE",
    sortByPivotReferences: [
        {
            fieldName: "Country",
            items: ["Germany"]
        },
        {
            fieldName: "Type1",
            items: ["MT"]
        }
    ]
};
pivotTable.sort("Level", sortInfo);

// Sort By Custom Callback
pivotTable.sort("Country", {
    customSortCallback: function (fieldItemNameArray) {
        return fieldItemNameArray.sort((a, b) => a.length - b.length);
    }
 });
Summary PivotTables can be sorted in the following ways: Sort By Field Item Name Sort By Value Sort By Custom Field Item Value Sort By Custom Callback The sortType can be set in any way. API Interface API Sample Code
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import { AppFunc } from './app-func'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app'));
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; const useState = React.useState, useEffect = React.useEffect; const GCsheets = GC.Spread.Sheets; function _getElementById(id) { return document.getElementById(id); } export function AppFunc() { const [selectedSortField, setSelectedSortField] = useState("Salesperson"); const [selectedSortType, setSelectedSortType] = useState("0"); const [selectedValueFieldName, setSelectedValueFieldName] = useState(""); const [spread, setSpread] = useState(""); const [pivotTable, setPivotTable] = useState(""); const [_rangeSelector, setRangeSelector] = useState(""); const sortFields = ["Salesperson", "Cars", "Date"]; const valueFieldNames = ["", "Quantity"]; const setSortInfo = () => { spread.suspendPaint(); let sortInfo = generateSortInfo(); if (sortInfo) { pivotTable.sort(selectedSortField, sortInfo); syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); } spread.resumePaint(); }; const clearSortInfo = () => { pivotTable.sort(selectedSortField, undefined); syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); }; useEffect(() => { if (spread) { spread.suspendPaint(); spread.setSheetCount(2); let sheet1 = spread.getSheet(0); let sheet2 = spread.getSheet(1); let tableName = getSource(sheet2, pivotSales); setPivotTable(addPivotTable(sheet1, tableName)); initFormulaTextBox(); spread.focus(); spread.resumePaint(); } }, [spread]); useEffect(() => { if (pivotTable) { syncSortInfo(); } }, [selectedSortField]); const initFormulaTextBox = () => { let host = _getElementById("formulaTextBox"); let rangeSelector = new GCsheets.FormulaTextBox.FormulaTextBox(host, { rangeSelectMode: true, absoluteReference: true, needSheetName: false }, spread); rangeSelector.workbook(spread); setRangeSelector(rangeSelector); } const getSource = (sheet, tableSource) => { sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0"); let table = sheet.tables.add('table', 0, 0, 117, 6); for (let i = 2; i <= 117; i++) { sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i) } table.style(GCsheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, tableSource); return table.name(); } const generateSortInfo = () => { let pivotReferences = initPivotReferences(); let sortInfo = { sortType: + selectedSortType }; if (selectedValueFieldName !== '') { sortInfo.sortValueFieldName = selectedValueFieldName; } if (pivotReferences) { sortInfo.sortByPivotReferences = pivotReferences; } return sortInfo; } const syncSortInfo = () => { let sortInfo = pivotTable.sort(selectedSortField); let sortType = sortInfo && sortInfo.sortType; if (sortType === undefined) { sortType = GC.Spread.Pivot.SortType.asc; } let sortValueFieldName = sortInfo && sortInfo.sortValueFieldName; if (sortValueFieldName === undefined) { sortValueFieldName = ''; } let pivotReferences = sortInfo && sortInfo.sortByPivotReferences; setSelectedSortType(sortType + '') setSelectedValueFieldName(sortValueFieldName); setPivotReferences(pivotReferences); } const initPivotReferences = () => { let cellRef = _rangeSelector.text(); if (!cellRef || !selectedValueFieldName) { return; } let sheet = spread.getActiveSheet(); let range = GCsheets.CalcEngine.formulaToRange(sheet, _rangeSelector.text()); if (range) { let row = range.row, col = range.col; if (sheet.pivotTables.findPivotTable(row, col)) { let pivotInfo = pivotTable.getPivotInfo(row, col); let fieldArea = pivotTable.getField(selectedSortField).pivotArea; let infos; if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.rowField) { infos = pivotInfo.colInfos; } if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.columnField) { infos = pivotInfo.rowInfos; } if (infos && infos.length > 0) { let isGrandTotal = infos.length === 1 && infos[0].isGrandTotal; if (!isGrandTotal) { // if is grand total, nothing to do. return infos.map((info) => { return { fieldName: info.fieldName, items: [info.itemName] }; }); } } } } } const setPivotReferences = (pivotReferences) => { let rangeStr = '', resultRow, resultCol; if (pivotReferences) { let refSourceNames = pivotReferences.map(ref => ref.fieldName); let allFields = pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.rowField).concat(pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.columnField)); let pivotArea = { references: allFields.map(function (field) { let index = refSourceNames.indexOf(field.sourceName); if (index !== -1) { return { fieldName: field.fieldName, items: pivotReferences[index].items } } else { return { fieldName: field.fieldName } } }) } let range = pivotTable.getPivotAreaRanges(pivotArea)[0]; resultRow = range.row; resultCol = range.col; rangeStr = GCsheets.CalcEngine.rangeToFormula(new GCsheets.Range(resultRow, resultCol, 1, 1)); } _rangeSelector.text(rangeStr); } const addPivotTable = (sheet, source) => { sheet.suspendPaint(); sheet.name("PivotTable"); sheet.setRowCount(10000); let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); pivotTable.suspendLayout(); pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [ { by: GC.Pivot.DateGroupType.quarters } ] }; pivotTable.group(groupInfo); pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField); pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pivotTable.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top; pivotTable.resumeLayout(); sheet.resumePaint(); pivotTable.autoFitColumn(); return pivotTable; } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={ spread => setSpread(spread) }></SpreadSheets> </div> <div className="options-container"> <div className="options-row"> <span>Sort Field</span> <select value={selectedSortField} onChange={ (event) => { setSelectedSortField(event.target.value); } }> { sortFields.map((option) => ( <option value={option}> {option} </option> )) } </select> </div> <div className="options-row"> <span>Sort Type</span> <label> <input type="radio" value="0" checked={ selectedSortType === "0" } onChange={ (event) => setSelectedSortType(event.target.value) } /> ASC </label> <label> <input type="radio" value="1" checked={ selectedSortType === "1" } onChange={ (event) => setSelectedSortType(event.target.value) } /> DESC </label> </div> <div className="options-row"> <span>Value Field Name</span> <select value={selectedValueFieldName} onChange={ (event) => setSelectedValueFieldName(event.target.value) }> { valueFieldNames.map((option) => ( <option value={option}> {option} </option> )) } </select> </div> <div className="options-row"> <span>Cell Ref</span> <div id='formulaTextBox' /> </div> <hr /> <div className="options-row"> <button onClick={setSortInfo}>Set Sort Info</button> </div> <div className="options-row"> <button onClick={clearSortInfo}>Clear Sort Info</button> </div> </div> </div> ); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 400px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 380px; padding: 10px; font-family: Arial, sans-serif; font-size: 14px; } .options-row { display: flex; align-items: center; margin-bottom: 10px; } .options-row span { flex: 1; margin-right: 10px; min-width: 100px; text-align: left; } .options-row select, .options-row input[type="text"] { flex: 2; padding: 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; } .options-row label { flex: 2; } .options-row label:first-of-type{ padding-left: 15px; } .options-row button { flex: 1; background-color: #007bff; color: #fff; padding: 5px 10px; border: none; border-radius: 3px; font-family: inherit; font-size: inherit; cursor: pointer; } .options-row button:hover { background-color: #0069d9; } #formulaTextBox { flex: 2; padding: 2px 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; background-color: #fff; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

PivotTable Sort

SpreadJS PivotTables support Sort Data. This function can be used to order and organize data.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

Summary

PivotTables can be sorted in the following ways:

  • Sort By Field Item Name
  • Sort By Value
  • Sort By Custom Field Item Value
  • Sort By Custom Callback

The sortType can be set in any way.

enum GC.Pivot.SortType {
    asc,
    desc,
    custom
}

API

Interface

interface GC.Pivot.ICustomSortCallBack
{
    (fieldItemNameArray: any[], sortInfo: GC.Pivot.IPivotCustomSortInfo) : any[];
}
// the usage here is a little different with pivot area, so the interface IPivotReference changes the display way. but actually they are same interface.
interface GC.Spread.Pivot.IPivotReference 
{
   fieldName: string;
   items: string[];
}
interface IPivotViewSortInfo
{
    sortType: GC.Pivot.SortType;
    sortValueFieldName?: string;
    sortByPivotReferences?: GC.Spread.Pivot.IPivotReference[];
    customSortCallback?: GC.Pivot.ICustomSortCallBack;
}

API

/**
 * @description get or set sort for a field of pivot table.
 * @param {string} fieldName Indicates the target field name.
 * @param {GC.Pivot.IPivotViewSortInfo} sortInfo Indicates the sort info.
 * @returns {GC.Pivot.IPivotViewSortInfo | void}
 **/
function sort(fieldName: string, sortInfo: GC.Pivot.IPivotViewSortInfo): GC.Pivot.IPivotViewSortInfo | void

Sample Code

// Get sort info
let sortInfo = pivotTable.sort("Country");

// Clear sort info
pivotTable.sort("Country", null);

// Sort By Field Item Name
var sortInfo = {
    sortType: GC.Pivot.SortType.asc
};
pivotTable.sort("Country", sortInfo);

// Sort By Value
var sortInfo = {
    sortType: GC.Pivot.SortType.asc, sortValueFieldName: 'DAMAGE'
};
pivotTable.sort("Country", sortInfo)

// Sort By Custom Field Item Value
var sortInfo = {
    sortType: GC.Pivot.SortType.desc,
    sortValueFieldName: "DAMAGE",
    sortByPivotReferences: [
        {
            fieldName: "Country",
            items: ["Germany"]
        },
        {
            fieldName: "Type1",
            items: ["MT"]
        }
    ]
};
pivotTable.sort("Level", sortInfo);

// Sort By Custom Callback
pivotTable.sort("Country", {
    customSortCallback: function (fieldItemNameArray) {
        return fieldItemNameArray.sort((a, b) => a.length - b.length);
    }
 });
Summary PivotTables can be sorted in the following ways: Sort By Field Item Name Sort By Value Sort By Custom Field Item Value Sort By Custom Callback The sortType can be set in any way. API Interface API Sample Code
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import { FormsModule } from '@angular/forms'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import './styles.css'; function _getElementById(id) { return document.getElementById(id); } @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { dataSource: any[]; spread: GC.Spread.Sheets.Workbook; hostStyle = { width: 'calc(100% - 400px)', height: '100%', overflow: 'hidden', float: 'left' }; pivotTable: any; selectedSortField = "Salesperson"; sortFields = ["Salesperson", "Cars", "Date"]; selectedSortType = "0"; selectedValueFieldName = ""; valueFieldNames = ["", "Quantity"]; _rangeSelector: any; constructor() {} initSpread($Event: any) { let spread = $Event.spread; this.spread = spread; spread.suspendPaint(); spread.setSheetCount(2); let sheet1 = spread.getSheet(0); let sheet2 = spread.getSheet(1); let tableName = this.getSource(sheet2, pivotSales); let pivotTable = this.addPivotTable(sheet1, tableName); this.pivotTable = pivotTable; this.initFormulaTextBox(spread); spread.focus(); spread.resumePaint(); } initFormulaTextBox(spread) { let host = _getElementById("formulaTextBox"); this._rangeSelector = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(host, { rangeSelectMode: true, absoluteReference: true, needSheetName: false }, spread); this._rangeSelector.workbook(spread); } getSource(sheet: GC.Spread.Sheets.Workbook, tableSource: any) { sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); let table = sheet.tables.add('table', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, tableSource); return table.name(); } setSortInfo (sortType: number) { let spread = this.spread; let pivotTable = this.pivotTable; let _rangeSelector = this._rangeSelector; spread.suspendPaint(); let sortInfo = this.generateSortInfo(); if (sortInfo) { pivotTable.sort(this.selectedSortField, sortInfo); this.syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); } spread.resumePaint(); } clearSortInfo () { let spread = this.spread; let pivotTable = this.pivotTable; let _rangeSelector = this._rangeSelector; pivotTable.sort(this.selectedSortField, undefined); this.syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); } generateSortInfo() { let pivotReferences = this.initPivotReferences(); let sortInfo: any = { sortType: +this.selectedSortType }; if (this.selectedValueFieldName !== '') { sortInfo.sortValueFieldName = this.selectedValueFieldName; } if (pivotReferences) { sortInfo.sortByPivotReferences = pivotReferences; } return sortInfo; } syncSortInfo() { let pivotTable = this.pivotTable; let sortInfo = pivotTable.sort(this.selectedSortField); let sortType = sortInfo && sortInfo.sortType; if (sortType === undefined) { sortType = GC.Spread.Pivot.SortType.asc; } this.selectedSortType = sortType + ''; let sortValueFieldName = sortInfo && sortInfo.sortValueFieldName; if (sortValueFieldName === undefined) { sortValueFieldName = ''; } this.selectedValueFieldName = sortValueFieldName; let pivotReferences = sortInfo && sortInfo.sortByPivotReferences; this.setPivotReferences(pivotReferences); } initPivotReferences() { let _rangeSelector = this._rangeSelector; let pivotTable = this.pivotTable; let cellRef = _rangeSelector.text(); if (!cellRef || !this.selectedValueFieldName) { return; } let spread = this.spread; let sheet = spread.getActiveSheet(); let range = GC.Spread.Sheets.CalcEngine.formulaToRange(sheet, _rangeSelector.text()); if (range) { let row = range.row, col = range.col; if (sheet.pivotTables.findPivotTable(row, col)) { let pivotInfo = pivotTable.getPivotInfo(row, col); let fieldArea = pivotTable.getField(this.selectedSortField).pivotArea; let infos; if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.rowField) { infos = pivotInfo.colInfos; } if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.columnField) { infos = pivotInfo.rowInfos; } if (infos && infos.length > 0) { let isGrandTotal = infos.length === 1 && infos[0].isGrandTotal; if (!isGrandTotal) { // if is grand total, nothing to do. return infos.map((info) => { return { fieldName: info.fieldName, items: [info.itemName] }; }); } } } } } setPivotReferences(pivotReferences) { let pivotTable = this.pivotTable; let rangeStr = '', resultRow, resultCol; if (pivotReferences) { let refSourceNames = pivotReferences.map(ref => ref.fieldName); let allFields = pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.rowField).concat(pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.columnField)); let pivotArea = { references: allFields.map(function (field) { let index = refSourceNames.indexOf(field.sourceName); if (index !== -1) { return { fieldName: field.fieldName, items: pivotReferences[index].items } } else { return { fieldName: field.fieldName } } }) } let range = pivotTable.getPivotAreaRanges(pivotArea)[0]; resultRow = range.row; resultCol = range.col; rangeStr = GC.Spread.Sheets.CalcEngine.rangeToFormula(new GC.Spread.Sheets.Range(resultRow, resultCol, 1, 1)); } this._rangeSelector.text(rangeStr); } addPivotTable(sheet: GC.Spread.Sheets.Workbook, source: any) { sheet.suspendPaint(); sheet.name("PivotTable"); sheet.setRowCount(10000); let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); pivotTable.suspendLayout(); pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; pivotTable.group(groupInfo); pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField); pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pivotTable.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top; pivotTable.resumeLayout(); sheet.resumePaint(); pivotTable.autoFitColumn(); return pivotTable; } } @NgModule({ imports: [BrowserModule, SpreadSheetsModule, FormsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> <div class="options-container"> <div class="options-row"> <span>Sort Field:</span> <select id="sort-field" [(ngModel)]="selectedSortField" (change)="syncSortInfo($event)"> <option *ngFor="let field of sortFields">{{field}}</option> </select> </div> <div class="options-row"> <span>Sort Type:</span> <label><input type="radio" name="sort-type" value="0" [(ngModel)]="selectedSortType">ASC</label> <label><input type="radio" name="sort-type" value="1" [(ngModel)]="selectedSortType">DESC</label> </div> <div class="options-row"> <span>Value Field Name:</span> <select id="value-field-name" [(ngModel)]="selectedValueFieldName"> <option *ngFor="let field of valueFieldNames">{{field}}</option> </select> </div> <div class="options-row"> <span>Cell Ref:</span> <div id="formulaTextBox"></div> </div> <hr> <div class="options-row"> <button class="set-sort-info-button" (click)="setSortInfo()">Set Sort Info</button> </div> <div class="options-row"> <button class="clear-sort-info-button" (click)="clearSortInfo()">Clear Sort Info</button> </div> </div> </div>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 400px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 380px; padding: 10px; font-family: Arial, sans-serif; font-size: 14px; } .options-row { display: flex; align-items: center; margin-bottom: 10px; } .options-row span { flex: 1; margin-right: 10px; min-width: 100px; text-align: left; } .options-row select, .options-row input[type="text"] { flex: 2; padding: 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; } .options-row label { flex: 2; } .options-row label:first-of-type{ padding-left: 15px; } .options-row button { flex: 1; background-color: #007bff; color: #fff; padding: 5px 10px; border: none; border-radius: 3px; font-family: inherit; font-size: inherit; cursor: pointer; } .options-row button:hover { background-color: #0069d9; } #formulaTextBox { flex: 2; padding: 2px 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; background-color: #fff; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

PivotTable Sort

SpreadJS PivotTables support Sort Data. This function can be used to order and organize data.

Description
app.vue
index.html
Copy to CodeMine

Summary

PivotTables can be sorted in the following ways:

  • Sort By Field Item Name
  • Sort By Value
  • Sort By Custom Field Item Value
  • Sort By Custom Callback

The sortType can be set in any way.

enum GC.Pivot.SortType {
    asc,
    desc,
    custom
}

API

Interface

interface GC.Pivot.ICustomSortCallBack
{
    (fieldItemNameArray: any[], sortInfo: GC.Pivot.IPivotCustomSortInfo) : any[];
}
// the usage here is a little different with pivot area, so the interface IPivotReference changes the display way. but actually they are same interface.
interface GC.Spread.Pivot.IPivotReference 
{
   fieldName: string;
   items: string[];
}
interface IPivotViewSortInfo
{
    sortType: GC.Pivot.SortType;
    sortValueFieldName?: string;
    sortByPivotReferences?: GC.Spread.Pivot.IPivotReference[];
    customSortCallback?: GC.Pivot.ICustomSortCallBack;
}

API

/**
 * @description get or set sort for a field of pivot table.
 * @param {string} fieldName Indicates the target field name.
 * @param {GC.Pivot.IPivotViewSortInfo} sortInfo Indicates the sort info.
 * @returns {GC.Pivot.IPivotViewSortInfo | void}
 **/
function sort(fieldName: string, sortInfo: GC.Pivot.IPivotViewSortInfo): GC.Pivot.IPivotViewSortInfo | void

Sample Code

// Get sort info
let sortInfo = pivotTable.sort("Country");

// Clear sort info
pivotTable.sort("Country", null);

// Sort By Field Item Name
var sortInfo = {
    sortType: GC.Pivot.SortType.asc
};
pivotTable.sort("Country", sortInfo);

// Sort By Value
var sortInfo = {
    sortType: GC.Pivot.SortType.asc, sortValueFieldName: 'DAMAGE'
};
pivotTable.sort("Country", sortInfo)

// Sort By Custom Field Item Value
var sortInfo = {
    sortType: GC.Pivot.SortType.desc,
    sortValueFieldName: "DAMAGE",
    sortByPivotReferences: [
        {
            fieldName: "Country",
            items: ["Germany"]
        },
        {
            fieldName: "Type1",
            items: ["MT"]
        }
    ]
};
pivotTable.sort("Level", sortInfo);

// Sort By Custom Callback
pivotTable.sort("Country", {
    customSortCallback: function (fieldItemNameArray) {
        return fieldItemNameArray.sort((a, b) => a.length - b.length);
    }
 });
Summary PivotTables can be sorted in the following ways: Sort By Field Item Name Sort By Value Sort By Custom Field Item Value Sort By Custom Callback The sortType can be set in any way. API Interface API Sample Code
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> <div class="options-container" style="float:right; width: 380px;"> <div> <div v-for="(option, index) in optionsRef" :key="index" class="options-row"> <span v-if="option.type === 'text'">{{ option.text }}</span> <span v-if="option.type === 'select'">{{ option.text }}</span> <select v-if="option.type === 'select'" :id="option.id" v-model="option.selected"> <option v-for="item in option.items" :key="item" :value="item">{{ item }}</option> </select> <input v-else-if="option.type === 'input'" :id="option.id" type="text" v-model="option.value"> <div v-if="option.type === 'radio-group'"> <span>{{ option.text }}</span> <label v-for="(item, i) in option.items" :key="i"> <input type="radio" :name="option.id" :id="option.id + i" :value="item.value" v-model="option.selected"> {{ item.label }} </label> </div> <button v-else-if="option.type === 'button'" :id="option.id" @click="option.click">{{ option.text }}</button> <div v-else-if="option.type === 'split-line'" style="border-bottom: 1px solid #ccc; margin: 10px 0;"></div> <span v-if="option.type === 'div'">{{ option.text }}</span> <div v-if="option.type === 'div'" :id="option.id"></div> </div> </div> </div> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-vue"; import { ref, shallowRef } from "vue"; import "@mescius/spread-sheets-pivot-addon"; let spreadRef = shallowRef(null); let pivotTableRef = shallowRef(null); let _rangeSelectorRef = ref(null); let optionsRef = ref([ { type: "select", text: "Sort Field", id: "sort-field", items: ["Salesperson", "Cars", "Date"], selected: "Salesperson" }, { type: "radio-group", text: "Sort Type", items: [ { value: "0", label: "Ascending" }, { value: "1", label: "Descending" }, ], selected: "0", }, { type: "select", text: "Value Field Name", id: "value-field-name", items: ["", "Quantity"], selected: "" }, { type: "div", text: "Cell Ref", id: "formulaTextBox" }, { type: "split-line" }, { type: "button", text: "Set Sort Info", id: "set-sort-info", click: handleSetSortInfoClick }, { type: "button", text: "Clear Sort Info", id: "clear-sort-info", click: handleClearSortInfoClick }, ]); function initSpread (spread) { spreadRef.value = spread; spread.suspendPaint(); spread.setSheetCount(2); let sheet1 = spread.getSheet(0); let sheet2 = spread.getSheet(1); let tableName = getSource(sheet2, pivotSales); let pivotTable = addPivotTable(sheet1, tableName); pivotTableRef.value = pivotTable; initFormulaTextBox(spread); spread.focus(); spread.resumePaint(); _getElementById("sort-field").addEventListener("change", () => {syncSortInfo()}); } function initFormulaTextBox(spread) { let host = _getElementById("formulaTextBox"); _rangeSelectorRef.value = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(host, { rangeSelectMode: true, absoluteReference: true, needSheetName: false }, spread); _rangeSelectorRef.value.workbook(spread); } function handleSetSortInfoClick() { let spread = spreadRef.value; let pivotTable = pivotTableRef.value; let _rangeSelector = _rangeSelectorRef.value; spread.suspendPaint(); let sortInfo = generateSortInfo(); if (sortInfo) { pivotTable.sort(optionsRef.value[0].selected, sortInfo); syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); } spread.resumePaint(); } function handleClearSortInfoClick() { let spread = spreadRef.value; let pivotTable = pivotTableRef.value; let _rangeSelector = _rangeSelectorRef.value; pivotTable.sort(optionsRef.value[0].selected, undefined); syncSortInfo(); _rangeSelector.endSelectMode(); spread.focus(); } function generateSortInfo() { let pivotReferences = initPivotReferences(); let sortInfo = { sortType: +optionsRef.value[1].selected }; let selectedValueFieldName = optionsRef.value[2].selected; if (selectedValueFieldName !== '') { sortInfo.sortValueFieldName = selectedValueFieldName; } if (pivotReferences) { sortInfo.sortByPivotReferences = pivotReferences; } return sortInfo; } function syncSortInfo() { let pivotTable = pivotTableRef.value; let sortInfo = pivotTable.sort(optionsRef.value[0].selected); let sortType = sortInfo && sortInfo.sortType; if (sortType === undefined) { sortType = GC.Spread.Pivot.SortType.asc; } optionsRef.value[1].selected = sortType + ''; let sortValueFieldName = sortInfo && sortInfo.sortValueFieldName; if (sortValueFieldName === undefined) { sortValueFieldName = ''; } optionsRef.value[2].selected = sortValueFieldName; let pivotReferences = sortInfo && sortInfo.sortByPivotReferences; setPivotReferences(pivotReferences); } function initPivotReferences() { let _rangeSelector = _rangeSelectorRef.value; let pivotTable = pivotTableRef.value; let cellRef = _rangeSelector.text(); if (!cellRef || !optionsRef.value[2].selected) { return; } let spread = spreadRef.value; let sheet = spread.getActiveSheet(); let range = GC.Spread.Sheets.CalcEngine.formulaToRange(sheet, _rangeSelector.text()); if (range) { let row = range.row, col = range.col; if (sheet.pivotTables.findPivotTable(row, col)) { let pivotInfo = pivotTable.getPivotInfo(row, col); let fieldArea = pivotTable.getField(optionsRef.value[0].selected).pivotArea; let infos; if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.rowField) { infos = pivotInfo.colInfos; } if (fieldArea === GC.Spread.Pivot.PivotTableFieldType.columnField) { infos = pivotInfo.rowInfos; } if (infos && infos.length > 0) { let isGrandTotal = infos.length === 1 && infos[0].isGrandTotal; if (!isGrandTotal) { // if is grand total, nothing to do. return infos.map((info) => { return { fieldName: info.fieldName, items: [info.itemName] }; }); } } } } } function setPivotReferences(pivotReferences) { let pivotTable = pivotTableRef.value; let rangeStr = '', resultRow, resultCol; if (pivotReferences) { let refSourceNames = pivotReferences.map(ref => ref.fieldName); let allFields = pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.rowField).concat(pivotTable.getFieldsByArea(GC.Spread.Pivot.PivotTableFieldType.columnField)); let pivotArea = { references: allFields.map(function (field) { let index = refSourceNames.indexOf(field.sourceName); if (index !== -1) { return { fieldName: field.fieldName, items: pivotReferences[index].items } } else { return { fieldName: field.fieldName } } }) } let range = pivotTable.getPivotAreaRanges(pivotArea)[0]; resultRow = range.row; resultCol = range.col; rangeStr = GC.Spread.Sheets.CalcEngine.rangeToFormula(new GC.Spread.Sheets.Range(resultRow, resultCol, 1, 1)); } _rangeSelectorRef.value.text(rangeStr); } function getSource (sheet, tableSource) { sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0"); let table = sheet.tables.add('table', 0, 0, 117, 6); for (let i = 2; i <= 117; i++) { sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, tableSource); return table.name(); } function addPivotTable (sheet, source) { sheet.suspendPaint(); sheet.name("PivotTable"); sheet.setRowCount(10000); let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); pivotTable.suspendLayout(); pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; pivotTable.group(groupInfo); pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField); pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pivotTable.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top; pivotTable.resumeLayout(); sheet.resumePaint(); pivotTable.autoFitColumn(); return pivotTable; } function _getElementById(id) { return document.getElementById(id); } </script> <style scoped> .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 400px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 380px; padding: 10px; font-family: Arial, sans-serif; font-size: 14px; } .options-row div { width: 100%; display: flex; } .options-row { display: flex; align-items: center; margin-bottom: 10px; } .options-row span { flex: 1; margin-right: 10px; min-width: 100px; text-align: left; } .options-row select, .options-row input[type="text"] { flex: 2; padding: 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; } .options-row label { flex: 2; } .options-row label:first-of-type{ padding-left: 15px; } .options-row button { flex: 1; background-color: #007bff; color: #fff; padding: 5px 10px; border: none; border-radius: 3px; font-family: inherit; font-size: inherit; cursor: pointer; } .options-row button:hover { background-color: #0069d9; } #formulaTextBox { flex: 2; padding: 2px 5px; border: 1px solid #ccc; border-radius: 3px; font-family: inherit; font-size: inherit; background-color: #fff; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ '../node_modules/*/package.json', "../node_modules/@mescius/*/package.json", "../node_modules/@babel/*/package.json", "../node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);